#!/usr/bin/env ruby
# ȥ
TITLE = <<-__TITLE__

NArray  RubyDCL ѤƸοư (ǤդνͤͿ) 
򵭽Ҥ Ruby ץ
(NArray ʬ⥸塼 NumRu::Derivative )

򤤤Ƥ뼰 d^2 u/dt^2 = d^2 u/dx^2

__TITLE__

# 
HISTORY = <<-__HISTORY__

  * 2006/06/13 (Yasuhiro MORIKAWA) 

__HISTORY__

# ԡ饤
COPYRIGHT = <<-__COPYRIGHT__

  Copyright (C) 2006 Yasuhiro MORIKAWA <morikawa@gfd-dennou.org>
                All rights reserved.

__COPYRIGHT__


# 饤֥, ⥸塼ɤ߹
require "numru/dcl"
require "date"
require "optparse"
require "numru/derivative"
include NumRu
include NMath

# ץ
opt = OptionParser.new ; OPTS = {}
ARGV.options{|opt|
  opt.on('-P', '--ps', "PS ե"
         ){|v| OPTS[:ps] = v}
  opt.on('-o=VAL', '--output=VAL', "PS եΥե̾"
         ){|v| OPTS[:output] = v.sub(/^\=/, '')}
  opt.on('--nowait', '--Gw', "˥᡼"
         ){|v| OPTS[:nowait] = v}
  opt.on('--alternate', '--Ga', "Хå󥰥ȥ"
         ){|v| OPTS[:alternate] = v}
  opt.on('--smooth', '--Gaw', "˥᡼ (Хå󥰥ȥ)"
         ){|v| OPTS[:nowait] = v ; OPTS[:alternate] = v}
  opt.on('-h','-H','--help', "إ"
         ){|v| puts TITLE ; puts opt ; puts COPYRIGHT; exit }
  opt.parse!
}
iws = OPTS[:ps] ? 2 : 1

#== 
# x 
XMin = 0.0                      # 
XMax = 2.0 * PI                 # 
NX   = 100                      # ֲ
DX   = (XMax - XMin) / ( NX )   # ֹ
x = NArray.float( NX + 1 ).indgen! * DX

# time 
TMin = 0.0                      # 
TMax = 100.0                    # ǽ
DT   = 0.05                     # ֹ
NT   = (TMax - TMin) / ( DT )   # ֥ƥå


# ѿ
u = NArray.float( NX + 1 )      # u

# 

(0..NX).each{|i|
  if i < NX/2
    u[i] = sin(x[i])
  else
    u[i] = sin(-2*x[i])/2
  end
}
u[0] = 0.0 ; u[NX] = 0.0           # 

dudt   = NArray.sfloat( NX + 1 )   # du/dt
dudx   = NArray.sfloat( NX + 1 )   # du/dx
d2udx2 = NArray.sfloat( NX + 1 )   # d^2u/dx^2

#== 
# ޥɥ饤󥪥ץ-psޤޤƤPSե(gropn(2)),
# ʤХɥ򳫤(gropn(1))

DCL::swlset('lalt',  true)  if OPTS[:alternate] # ΢
DCL::swlset('lwait', false) if OPTS[:nowait]    # ˥᡼
DCL::gropn(iws)

(0..NT).each{|i|
  DCL::grfrm
  DCL::grswnd(XMin, XMax, -1, 1)         # κɸ
  DCL::ussttl('X', '1', 'U', '1')     # ȥ
  DCL::usgrph(x, u)          # ͤ

  dudx = Derivative::cderiv(u, x, 0)
  d2udx2 = Derivative::cderiv(dudx, x, 0)
  dudt = dudt + d2udx2 * DT   # {du/dt(t+t) - du/dt(t)} / t = d^2 u/dx^2
  u = u + dudt * DT           # {u(t+t) - u(t)} / t = du/dt
  u[0] = 0.0 ; u[NX] = 0.0         # 
  dudt[0] = 0.0 ; dudt[NX] = 0.0   # 
}
DCL::grcls

# ̾ѹ
if OPTS[:ps]
  if OPTS[:output]
    fname = OPTS[:output]
    File.rename("dcl.ps", fname)
    print "#{fname} is output.\n"
  else
    print "dcl.ps is output.\n"
  end
end
